# $Id: freedb_misc.rb,v 1.1 2002/01/19 17:21:09 moumar Exp $ 
require 'socket'

class Freedb
  VERSION = "0.2"
  attr_reader :results, :artist, :title, :tracks
  
  def initialize(device = "/dev/cdrom")
    @id = get_cdrom(device)
    @tracks = Array.new()
  end

  def fetch(server = "us.freedb.org", port = "8880")
    @socket = TCPSocket.new(server, port)
    @socket.gets #banner
    @socket.puts("cddb hello me here ruby-freedb #{VERSION}")
    @socket.gets #welcome
    @socket.puts("cddb query #{@id}")
    resp = @socket.gets
    case resp
      when /^200/ #single result
	md = /^200 (.*)/.match(resp)
        @results = []
	@results << md[1]
      when /^202/
	raise(FreedbError, "No match found")
      when /^211/
	@results = getmultiline()
    end
  end

  def get_result(index)
    line = /\w+ \w+/.match(@results[index])
    @socket.puts("cddb read #{line}")
    lines = getmultiline()
    lines.each { |line|
      case line
        when /^DTITLE=/
	  md = /DTITLE=(.*) \/ (.*)/.match(line)
	  @artist = md[1]
	  @title = md[2]
	when /^TTITLE\d+=/
	  md = /^TTITLE\d+=(.*)/.match(line)
	  @tracks << md[1]
      end
    }
  end

  def close
    @socket.close
  end
private  
  def getmultiline
    arr = []
    until (l = @socket.gets) =~ /^\./
      arr << l.strip
    end
    return arr
  end

end
